<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FilterExitManagement StructType
 * @subpackage Structs
 */
class FilterExitManagement extends AbstractStructBase
{
    /**
     * The filterEnd
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $filterEnd;
    /**
     * The filterOutOfRange
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $filterOutOfRange;
    /**
     * The filterExitManagementExtension
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ExtensionType
     */
    public $filterExitManagementExtension;
    /**
     * Constructor method for FilterExitManagement
     * @uses FilterExitManagement::setFilterEnd()
     * @uses FilterExitManagement::setFilterOutOfRange()
     * @uses FilterExitManagement::setFilterExitManagementExtension()
     * @param bool $filterEnd
     * @param bool $filterOutOfRange
     * @param \StructType\ExtensionType $filterExitManagementExtension
     */
    public function __construct($filterEnd = null, $filterOutOfRange = null, \StructType\ExtensionType $filterExitManagementExtension = null)
    {
        $this
            ->setFilterEnd($filterEnd)
            ->setFilterOutOfRange($filterOutOfRange)
            ->setFilterExitManagementExtension($filterExitManagementExtension);
    }
    /**
     * Get filterEnd value
     * @return bool
     */
    public function getFilterEnd()
    {
        return $this->filterEnd;
    }
    /**
     * Set filterEnd value
     * @param bool $filterEnd
     * @return \StructType\FilterExitManagement
     */
    public function setFilterEnd($filterEnd = null)
    {
        // validation for constraint: boolean
        if (!is_null($filterEnd) && !is_bool($filterEnd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($filterEnd)), __LINE__);
        }
        $this->filterEnd = $filterEnd;
        return $this;
    }
    /**
     * Get filterOutOfRange value
     * @return bool
     */
    public function getFilterOutOfRange()
    {
        return $this->filterOutOfRange;
    }
    /**
     * Set filterOutOfRange value
     * @param bool $filterOutOfRange
     * @return \StructType\FilterExitManagement
     */
    public function setFilterOutOfRange($filterOutOfRange = null)
    {
        // validation for constraint: boolean
        if (!is_null($filterOutOfRange) && !is_bool($filterOutOfRange)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($filterOutOfRange)), __LINE__);
        }
        $this->filterOutOfRange = $filterOutOfRange;
        return $this;
    }
    /**
     * Get filterExitManagementExtension value
     * @return \StructType\ExtensionType|null
     */
    public function getFilterExitManagementExtension()
    {
        return $this->filterExitManagementExtension;
    }
    /**
     * Set filterExitManagementExtension value
     * @param \StructType\ExtensionType $filterExitManagementExtension
     * @return \StructType\FilterExitManagement
     */
    public function setFilterExitManagementExtension(\StructType\ExtensionType $filterExitManagementExtension = null)
    {
        $this->filterExitManagementExtension = $filterExitManagementExtension;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FilterExitManagement
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
